## ros-lunar-rc-dynamics-api 0.7.1

=== CMakeLists.txt ===
# This file is part of the rc_dynamics_api package.
#
# Copyright (c) 2017 Roboception GmbH
# All rights reserved
#
# Author: Christian Emmerich
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its contributors
# may be used to endorse or promote products derived from this software without
# specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.


cmake_minimum_required (VERSION 2.8.12)

project(rc_dynamics_api)
include(cmake/project_version.cmake)

enable_testing()

include_directories(${CMAKE_CURRENT_SOURCE_DIR})

# - Configuration for code optimization -

if (NOT CMAKE_BUILD_TYPE)
  set(CMAKE_BUILD_TYPE RELEASE CACHE STRING "Build type: DEBUG or RELEASE" FORCE)
endif ()

# - Standard definitions -

add_definitions(-Wall)
if (CMAKE_MAJOR_VERSION VERSION_LESS "3.1.0")
  add_definitions(-std=c++11)
else ()
  set(CMAKE_CXX_STANDARD 11)
endif ()

if (CMAKE_COMPILER_IS_GNUCC)
  add_definitions(-Wno-unknown-pragmas)
endif ()

if (MSVC)
  set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS TRUE)

  # Switching off some compiler warnings

  add_definitions("/wd4061")
  add_definitions("/wd4125")
  add_definitions("/wd4146")
  add_definitions("/wd4265")
  add_definitions("/wd4355")
  add_definitions("/wd4365")
  add_definitions("/wd4371")
  add_definitions("/wd4514")
  add_definitions("/wd4571")
  add_definitions("/wd4625")
  add_definitions("/wd4626")
  add_definitions("/wd4647")
  add_definitions("/wd4668")
  add_definitions("/wd4706")
  add_definitions("/wd4710")
  add_definitions("/wd4711")
  add_definitions("/wd4800")
  add_definitions("/wd4820")
  add_definitions("/wd4946")
  add_definitions("/wd4996")
  add_definitions("/wd5026")
  add_definitions("/wd5027")
endif ()

# - Build individual parts -

option(BUILD_DOC "Add target for building doxygen docs" ON)
option(BUILD_EXAMPLES "Build test programs" ON)
option(BUILD_TOOLS "Build commandline tools" ON)
option(BUILD_SHARED_LIBS "Build shared libs" ON)

add_subdirectory(rc_dynamics_api)
if (BUILD_TOOLS)
  add_subdirectory(tools)
endif ()
if (BUILD_EXAMPLES)
  add_subdirectory(examples)
endif()

# export project targets

# Declare (shared) libraries that are created by your project. For all
# libraries that appear here, the following line should exist in a cmake
# file in a sub directory:
# install(TARGETS rcXXX EXPORT PROJECTTargets COMPONENT bin DESTINATION lib)
if (BUILD_SHARED_LIBS)
  set(PROJECT_LIBRARIES rc_dynamics_api)
endif ()

# Declare static libraries that are created by your project. For all
# libraries that appear here, the following line should exist in a cmake
# file in a sub directory:
# install(TARGETS rcXXX_static EXPORT PROJECTTargets COMPONENT dev DESTINATION lib)
#set(PROJECT_STATIC_LIBRARIES rc_dynamics_api_static)

include(cmake/configure_link_libs.cmake)

# add a target to generate API documentation with Doxygen
if (BUILD_DOC)
  add_subdirectory(doc)
endif()

# Install catkin package.xml
install(FILES package.xml COMPONENT dev DESTINATION share/${PROJECT_NAME_LOWER})

# - Define information for packaging -

# optionally set description and maintainer (if not set will use defaults from package_debian.cmake)
#set(CPACK_DEBIAN_PACKAGE_DESCRIPTION "Roboception package description")

# optionally set package maintainer (otherwise defaults to Roboception <info@roboception.de>)
#set(CPACK_DEBIAN_PACKAGE_MAINTAINER "Your Name <your.name@roboception.de>")

# optionally specify dependencies of the debian package here (comma separated!)
#set(CPACK_DEBIAN_PACKAGE_DEPENDS "genicam (>= 1.0.0)")

include(cmake/package_debian.cmake)

=== examples/CMakeLists.txt ===
# This file is part of the rc_dynamics_api package.
#
# Copyright (c) 2017 Roboception GmbH
# All rights reserved
#
# Author: Christian Emmerich
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions are met:
#
# 1. Redistributions of source code must retain the above copyright notice,
# this list of conditions and the following disclaimer.
#
# 2. Redistributions in binary form must reproduce the above copyright notice,
# this list of conditions and the following disclaimer in the documentation
# and/or other materials provided with the distribution.
#
# 3. Neither the name of the copyright holder nor the names of its contributors
# may be used to endorse or promote products derived from this software without
# specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"
# AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
# IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
# ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE
# LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
# POSSIBILITY OF SUCH DAMAGE.

project(examples CXX)

# build programs

include_directories(BEFORE ${CMAKE_CURRENT_BINARY_DIR}/../rc_dynamics_api) # generated protobuf headers

add_executable(simple_receiver simple_receiver.cc)
target_link_libraries(simple_receiver rc_dynamics_api_static)

add_executable(test_slam test_slam.cc)
target_link_libraries(test_slam rc_dynamics_api_static)

# install tools

#install(TARGETS simple_receiver COMPONENT bin DESTINATION bin)

=== rc_dynamics_api/opt/CMakeLists.txt ===
# unset version variables
unset(PROJECT_VERSION)
unset(PACKAGE_VERSION)

if (MSVC)
  # Switching off compiler warnings in sub-modules and generated code
  add_definitions("/wd4013")
  add_definitions("/wd4061")
  add_definitions("/wd4062")
  add_definitions("/wd4090")
  add_definitions("/wd4100")
  add_definitions("/wd4125")
  add_definitions("/wd4127")
  add_definitions("/wd4242")
  add_definitions("/wd4255")
  add_definitions("/wd4265")
  add_definitions("/wd4267")
  add_definitions("/wd4296")
  add_definitions("/wd4310")
  add_definitions("/wd4312")
  add_definitions("/wd4365")
  add_definitions("/wd4388")
  add_definitions("/wd4389")
  add_definitions("/wd4456")
  add_definitions("/wd4457")
  add_definitions("/wd4505")
  add_definitions("/wd4514")
  add_definitions("/wd4548")
  add_definitions("/wd4574")
  add_definitions("/wd4623")
  add_definitions("/wd4625")
  add_definitions("/wd4626")
  add_definitions("/wd4647")
  add_definitions("/wd4668")
  add_definitions("/wd4701")
  add_definitions("/wd4702")
  add_definitions("/wd4703")
  add_definitions("/wd4710")
  add_definitions("/wd4711")
  add_definitions("/wd4738")
  add_definitions("/wd4774")
  add_definitions("/wd4820")
  add_definitions("/wd4946")
  add_definitions("/wd5026")
  add_definitions("/wd5027")
endif ()

# Submodule: CPR

if (WIN32)
  option(CMAKE_USE_OPENSSL "Use OpenSSL code. Experimental" OFF)
endif ()

## disabling tests for cpr as googletests cause some issue in catkin workflow:
#  "CMake Error at cpr/opt/googletest/cmake/internal_utils.cmake:145 (add_library):
#  add_library cannot create target "gtest" because another target with the
#  same name already exists.  The existing target is a shared library created
#  in source directory "/usr/src/gtest".  See documentation for policy CMP0002
#  for more details.
#  Call Stack (most recent call first):
#  cpr/opt/googletest/cmake/internal_utils.cmake:168 (cxx_library_with_type)
#  cpr/opt/googletest/CMakeLists.txt:80 (cxx_library)"
set(BUILD_CPR_TESTS OFF CACHE BOOL "Don't build cpr tests")

# build cpr as static library with position independent code
set(BUILD_SHARED_LIBS OFF)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)

option(USE_SYSTEM_CURL "If ON, this project will look in the system paths for an installed curl library" ON)

if (USE_SYSTEM_CURL)
  find_package(CURL)
endif ()

if (NOT USE_SYSTEM_CURL OR NOT CURL_FOUND)
  set(USE_SYSTEM_CURL OFF CACHE BOOL "If ON, this project will look in the system paths for an installed curl library" FORCE)

  set(BUILD_CURL_EXE ON CACHE BOOL "Build CURL command line tool")
  set(BUILD_TESTING OFF CACHE BOOL "Build testing tree")
endif ()

add_subdirectory(cpr)

# Submodule: JSON

set(JSON_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/json/src PARENT_SCOPE)

# Submodule: Protobuf

option(USE_SYSTEM_PROTOBUF "If ON, this project will look in the system paths for an installed protobuf compiler and library" ON)

if (USE_SYSTEM_PROTOBUF)
  set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} "${CMAKE_CURRENT_SOURCE_DIR}/../../cmake/Modules/")
  find_package(ProtocolBuffers)

  if (NOT PROTOBUF_LIBRARY OR NOT PROTOBUF_INCLUDE_DIR OR NOT PROTOBUF_PROTOC_EXECUTABLE)
    set(USE_SYSTEM_PROTOBUF OFF CACHE BOOL "If ON, this project will look in the system paths for an installed protobuf compiler or library" FORCE)
  endif ()
endif ()

if (NOT USE_SYSTEM_PROTOBUF)
  message(STATUS "Not using system Protobuf, using built-in protobuf project instead.")

  option(protobuf_BUILD_EXAMPLES "Build examples" OFF)
  option(protobuf_BUILD_SHARED_LIBS "Build shared libraries" OFF)
  option(protobuf_BUILD_TESTS "Build tests" OFF)
  option(protobuf_INSTALL_EXAMPLES "Build tests" OFF)

  if (WIN32)
    option(protobuf_MSVC_STATIC_RUNTIME "Set using static runtime under windows" OFF)
  endif ()

  add_subdirectory(protobuf/cmake)

  set(PROTOBUF_FOUND TRUE CACHE INTERNAL "Protobuf found")
  set(PROTOBUF_PROTOC_EXECUTABLE protoc CACHE INTERNAL "Protobuf protoc")
  set(PROTOBUF_INCLUDE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/protobuf/src" CACHE INTERNAL "Protobuf include directory")
  set(PROTOBUF_LIBRARY libprotobuf CACHE INTERNAL "Protobuf libprotobuf")
  set(PROTOBUF_LIBRARIES "" CACHE INTERNAL "Protobuf support libraries")

  set_property(TARGET protoc PROPERTY FOLDER "external")
  set_property(TARGET libprotobuf PROPERTY FOLDER "external")
  set_property(TARGET libprotobuf-lite PROPERTY FOLDER "external")
  set_property(TARGET libprotoc PROPERTY FOLDER "external")
endif()

=== rc_dynamics_api/opt/cpr/cpr/CMakeLists.txt ===
message(STATUS "Using CURL_INCLUDE_DIRS: ${CURL_INCLUDE_DIRS}.")
include_directories(
    ${CPR_INCLUDE_DIRS}
    ${CURL_INCLUDE_DIRS})

add_library(${CPR_LIBRARIES}

    # Source files
    auth.cpp
    cookies.cpp
    cprtypes.cpp
    digest.cpp
    error.cpp
    multipart.cpp
    parameters.cpp
    payload.cpp
    proxies.cpp
    session.cpp
    timeout.cpp
    util.cpp
    ssl_options.cpp

    # Header files (useful in IDEs)
    "${CPR_INCLUDE_DIRS}/cpr/api.h"
    "${CPR_INCLUDE_DIRS}/cpr/auth.h"
    "${CPR_INCLUDE_DIRS}/cpr/body.h"
    "${CPR_INCLUDE_DIRS}/cpr/cookies.h"
    "${CPR_INCLUDE_DIRS}/cpr/cpr.h"
    "${CPR_INCLUDE_DIRS}/cpr/cprtypes.h"
    "${CPR_INCLUDE_DIRS}/cpr/curlholder.h"
    "${CPR_INCLUDE_DIRS}/cpr/defines.h"
    "${CPR_INCLUDE_DIRS}/cpr/digest.h"
    "${CPR_INCLUDE_DIRS}/cpr/error.h"
    "${CPR_INCLUDE_DIRS}/cpr/max_redirects.h"
    "${CPR_INCLUDE_DIRS}/cpr/multipart.h"
    "${CPR_INCLUDE_DIRS}/cpr/parameters.h"
    "${CPR_INCLUDE_DIRS}/cpr/payload.h"
    "${CPR_INCLUDE_DIRS}/cpr/proxies.h"
    "${CPR_INCLUDE_DIRS}/cpr/response.h"
    "${CPR_INCLUDE_DIRS}/cpr/session.h"
    "${CPR_INCLUDE_DIRS}/cpr/timeout.h"
    "${CPR_INCLUDE_DIRS}/cpr/util.h"
    "${CPR_INCLUDE_DIRS}/cpr/ssl_options.h")

message(STATUS "Using CURL_LIBRARIES: ${CURL_LIBRARIES}.")
target_link_libraries(${CPR_LIBRARIES}
    ${CURL_LIBRARIES})

=== debian/changelog ===
ros-lunar-rc-dynamics-api (0.7.1-0xenial) xenial; urgency=high

  * update cmake files for version and packaging

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 03 Feb 2019 23:00:00 -0000

ros-lunar-rc-dynamics-api (0.7.0-0xenial) xenial; urgency=high

  * add saveSlamMap, loadSlamMap and removeSlamMap methods
  * getSlamTrajectory doesn't time out by default anymore

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 01 Jul 2018 22:00:00 -0000

ros-lunar-rc-dynamics-api (0.6.0-0xenial) xenial; urgency=high

  * add methods to access slam "reset" service
  * use single json.hpp include instead of submodule

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 18 Apr 2018 22:00:00 -0000

ros-lunar-rc-dynamics-api (0.5.0-0xenial) xenial; urgency=high

  * Updates for rc_visard image version v1.1.x with support for SLAM
  * added startSlam, restartSlam, stopSlam and getTrajectory
  * support Windows build

 -- Felix Ruess <felix.ruess@roboception.de>  Sun, 25 Feb 2018 23:00:00 -0000

ros-lunar-rc-dynamics-api (0.4.0-0xenial) xenial; urgency=high

  * refactoring: simplified csv-printing in rcdynamics_stream tool
  * refactoring: better exception handling
  * refactoring: renaming, wording is now PbMsgType instead of ProtoType
  * added '-l option' to rcdynamics_stream tool: list avail. streams
  * improvements and bug fixes in cmake
  * use rc_dynamics_msgs submodule

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 26 Sep 2017 22:00:00 -0000

ros-lunar-rc-dynamics-api (0.3.0-0xenial) xenial; urgency=high

  * start/stop rc_dynamics node instead of rc_stereo_ins
  * don't start/stop rc_dynamics for imu stream

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 05 Sep 2017 22:00:00 -0000

ros-lunar-rc-dynamics-api (0.2.1-0xenial) xenial; urgency=high

  * bug fix: header not installed

 -- Felix Ruess <felix.ruess@roboception.de>  Wed, 30 Aug 2017 22:00:00 -0000

ros-lunar-rc-dynamics-api (0.2.0-0xenial) xenial; urgency=high

  * bug fix: wrong name of tool: vins_stream -> rcdynamics_stream

 -- Felix Ruess <felix.ruess@roboception.de>  Tue, 29 Aug 2017 22:00:00 -0000

ros-lunar-rc-dynamics-api (0.1.0-0xenial) xenial; urgency=high

  * Initial release

 -- Felix Ruess <felix.ruess@roboception.de>  Mon, 28 Aug 2017 22:00:00 -0000

=== debian/control ===
Source: ros-lunar-rc-dynamics-api
Section: misc
Priority: extra
Maintainer: Felix Ruess <felix.ruess@roboception.de>
Build-Depends: debhelper (>= 9.0.0), cmake, curl, libcurl4-openssl-dev, libprotobuf-dev, libprotoc-dev, protobuf-compiler
Homepage: http://rc-visard.com
Standards-Version: 3.9.2

Package: ros-lunar-rc-dynamics-api
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, curl, libcurl4-openssl-dev, libprotobuf9v5, ros-lunar-catkin
Description: The rc_dynamics_api provides an API for easy handling of the dynamic-state data streams provided by Roboception's stereo camera with self-localization.
 See http://rc-visard.com Dynamic-state estimates of the rc_visard relate to its self-localization and ego-motion estimation. These states refer to rc_visard's current pose, velocity, or acceleration and are published on demand via several data streams. For a complete list and descriptions of these dynamics states and the respective data streams please refer to rc_visard's user manual.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1
# TODO: remove the LDFLAGS override.  It's here to avoid esoteric problems
# of this sort:
#  https://code.ros.org/trac/ros/ticket/2977
#  https://code.ros.org/trac/ros/ticket/3842
export LDFLAGS=
export PKG_CONFIG_PATH=/opt/ros/lunar/lib/pkgconfig
# Explicitly enable -DNDEBUG, see:
# 	https://github.com/ros-infrastructure/bloom/issues/327
export DEB_CXXFLAGS_MAINT_APPEND=-DNDEBUG

%:
	dh $@ -v --buildsystem=cmake

override_dh_auto_configure:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_configure -- -DCMAKE_INSTALL_PREFIX="/opt/ros/lunar"

override_dh_auto_build:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_build

override_dh_auto_test:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	echo -- Running tests. Even if one of them fails the build is not canceled.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_test || true

override_dh_shlibdeps:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_shlibdeps -l$(CURDIR)/debian/ros-lunar-rc-dynamics-api//opt/ros/lunar/lib/

override_dh_auto_install:
	# In case we're installing to a non-standard location, look for a setup.sh
	# in the install tree that was dropped by catkin, and source it.  It will
	# set things like CMAKE_PREFIX_PATH, PKG_CONFIG_PATH, and PYTHONPATH.
	if [ -f "/opt/ros/lunar/setup.sh" ]; then . "/opt/ros/lunar/setup.sh"; fi && \
	dh_auto_install
